from reactor_code_framework.analog_to_digital_converter.generic_adc import GenericADC

#Import any other modules here.

#This class is intended to be used as a template for making new
#analog-to-digital converter classes.
class TemplateADC(GenericADC):
  def __init__(self, reactor_manager, POSITION OR ADDRESS, GAIN SETTING):
    #Create and store any classes necessary to interface with the hardware.

    #Store any variables to check the parameters of the ADC.

    #Store any variables used to translate the pin names to the underlying
    #implementation.

    super().__init__(reactor_manager, "TemplateADC", TUPLE OF ALL PINS, 
                     TUPLE OF ALL VALID SINGLE ENDED PINS, 
                     TUPLE OF ALL VALID POSITIVE-NEGATIVE PIN PAIRS, 
                     GAIN INFO, POSITION OR ADDRESS INFO)

  #Check that the parameters are valid.
  def check_parameters(self):
    super().check_parameters()

    if #gain is not valid:
      raise Exception(DETAILED ERROR MESSAGE)
    
    #Check any other parameters. Raise exceptions if not valid.

  #Given a gain setting (gain), store the gain and set the gain. 
  def set_gain(self, gain):
    if #new gain is not valid:
      raise Exception(DETAILED ERROR MESSAGE)
    
    self.gain = gain
    
    #Set the gain by interacting with the hardware.

  #Given a pin and a mode ("voltage" or "value"), read the channel at the given 
  #pin and return the voltage or value (whichever was specified).
  #NOTE: some analog-to-digital converters may only be able to read the voltage
  #or value (maybe not both).
  def read_single_ended(self, pin, mode):
    super().read_single_ended(pin, mode)
    
    #Write code to interface with the ADC to read a single pin.

    if mode == "value":
      return #Write code to read and return a non-voltage value from the ADC.
    elif mode == "voltage":
      return #Write code to read and return a voltage value from the ADC.
  
  #Given a positive pin-negative pin pair  and a mode ("voltage" or "value"), 
  #read the differential channel batween these two pins and return the voltage 
  #or value difference (whichever was specified).
  #NOTE: some analog-to-digital converters may only be able to read the voltage
  #or value (maybe not both).
  def read_differential(self, positive_pin, negative_pin, mode):
    super().read_differential(positive_pin, negative_pin, mode)
    
    #Write code to interface with the ADC to read a differential (i.e. positive
    #pin value or voltage minus negative pin value or voltage).

    if mode == "value":
      return #Write code to read and return a non-voltage differential value.
    elif mode == "voltage":
      return #Write code to read and return the voltage differential.
  
  #No cleanup is needed for this hardware.
  def cleanup(self):
    #Write code to cleanup the hardware.