#This class is designed to manage instances of software classes, like Timer.
class SoftwareManager(object):
  #Store an instance of ReactorManager as reactor_manager.
  def __init__(self, reactor_manager):
    self.reactor_manager = reactor_manager
    self.software_elements = []
  
  #Represent the software manager as a string.
  def __repr__(self):
    software_manager_string =  "Software Manager:\nInstances of Software Classes:\n"
    for software_element in self.software_elements:
      software_manager_string = software_manager_string + str(software_element) + "\n"
    #Remove the last new line "\n" character because it is not needed.
    software_manager_string = software_manager_string[:-1]
    return software_manager_string

  #Check that the software element has a callable cleanup method.
  def check_software_element(self, software_element):
    cleanup_fn = getattr(software_element, "cleanup", None)
    if not callable(cleanup_fn):
      raise Exception("Software Element {0} does not have a cleanup method defined. Please define this method!".format(software_element))

  #Add a software element to the software manager.
  def add_software_element(self, software_element):
    self.check_software_element(software_element)
    self.software_elements.append(software_element)

  #Cleanup all the software elements.
  def cleanup(self):
    for software_element in self.software_elements:
      software_element.cleanup()